<?php

namespace Teknisa\EST\Modules\Relatorios\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;


class Est32100EvolucaoDeCustoController {
    protected $reportService;
    protected $environment;

    public function __construct($environment, ReportService $reportService) {
        $this->environment   = $environment;
        $this->reportService = $reportService;
    }

    public function generateReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $nrorg = $this->environment->getNrOrgTrab();
        $reportStrategy = array (
            'strategy' => 'BIRT',
            'parameterMapping' => array (
                "CDFILIAL"     => "P_CDFILIAL",
                "DTPERINI"     => "P_DTINICIAL",
                "DTPERFIN"     => "P_DTFINAL",
                "CDARVPRODINI"    => "P_CDPRODINI",
                "CDARVPRODFIN"    => "P_CDPRODFIN",
                "PERMINIMO"    => "P_PERMINIMO",
                "NRORG"        => "P_NRORG"
            )
        );
        
        $reportName = 'Est32100EvolCust';//$row['REPORT_NAME'];
        
        if($row['PERMINIMO'] == '')
            $row['PERMINIMO'] = 0;
        
        $parametersRow = array();

        foreach ($reportStrategy['parameterMapping'] as $fieldName => $paramName) {
            
            if ($row->has($fieldName)) $parametersRow[$paramName] = $row->get($fieldName);
        }
     
        $parametersRow['P_NRORG'] = $nrorg;
        $parametersRow['__format'] = $row['__format'];
        $birtURL = $this->reportService->createRemoteReport('BIRT', $reportName, $parametersRow);

        $response->addDataset(new DataSet('URL',array($birtURL)));
    }
}